<template>
  <nav id="RTE__toolbar">
    <v-toolbar height="auto">
      <v-toolbar-items>
        <bold @click="onClick" class="RTE__rich__text__button" v-if="display.bold"/>
        <italic @click="onClick" class="RTE__rich__text__button" v-if="display.italic"/>
        <underline @click="onClick" class="RTE__rich__text__button" v-if="display.underline"/>
        <removeFormat @click="onClick" class="RTE__rich__text__button" v-if="display.removeFormat"/>
        <orderedList @click="onClick" class="RTE__rich__text__button" v-if="display.orderedList"/>
        <unorderedList @click="onClick" class="RTE__rich__text__button" v-if="display.unorderedList"/>
        <undo @click="onClick" class="RTE__rich__text__button" v-if="display.undo"/>
        <redo @click="onClick" class="RTE__rich__text__button" v-if="display.redo"/>
      </v-toolbar-items>
    </v-toolbar>
  </nav>
</template>

<script>
import Bold from './Buttons/Bold'
import Italic from './Buttons/Italic'
import Underline from './Buttons/Underline'
import RemoveFormat from './Buttons/RemoveFormat'
import OrderedList from './Buttons/OrderedList'
import UnorderedList from './Buttons/UnorderedList'
import Undo from './Buttons/Undo'
import Redo from './Buttons/Redo'

export default {
  name: 'Toolbar',
  components: {
    'bold': Bold,
    'italic': Italic,
    'underline': Underline,
    'removeFormat': RemoveFormat,
    'orderedList': OrderedList,
    'unorderedList': UnorderedList,
    'undo': Undo,
    'redo': Redo,
  },
  props: {
    buttonsDisplay: {
      type: Object,
      required: false
    }
  },
  data () {
    return {
      selection: {
        selectionObject: null,
        range: null
      },
      display: {}
    }
  },
  created () {
    this.display = {
      bold: true,
      italic: true,
      underline: true,
      removeFormat: true,
      orderedList: true,
      unorderedList: true,
      undo: true,
      redo: true,
      ...this.buttonsDisplay
    }
  },
  methods: {
    onClick (event) {
      document.execCommand(event, false);
    }
  }
}
</script>

<style lang="scss" scoped>
  #RTE__toolbar {
    width: 100%;
    
    .v-toolbar__items {
      display: flex;
      flex-wrap: wrap;
      justify-content: space-around;
      width: 100%;

      > .v-btn {
        height: 40px !important;
      }
    }
  }
</style>
